/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.Logger
 *  fire.log.YYLogger
 *  fire.log.beans.ItemBaseBean
 *  fire.log.beans.RegBean
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.PropRole
 *  fire.pb.fushi.PAddFuShi
 *  fire.pb.game.Sregreward
 *  fire.pb.item.Pack
 *  fire.pb.talk.MessageMgr
 *  fire.pb.util.MessageUtil
 *  fire.pb.util.singlefactory.SingleContainer
 *  mkdb.Procedure
 *  xbean.RegDay
 *  xbean.RegMonth
 *  xbean.RegRec
 */
package fire.pb.activity.reg;

import fire.log.Logger;
import fire.log.YYLogger;
import fire.log.beans.ItemBaseBean;
import fire.log.beans.RegBean;
import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.PropRole;
import fire.pb.activity.reg.PQueryRegRec;
import fire.pb.activity.reg.RegAssistant;
import fire.pb.activity.reg.RoleProcedure;
import fire.pb.fushi.PAddFuShi;
import fire.pb.game.Sregreward;
import fire.pb.item.Pack;
import fire.pb.talk.MessageMgr;
import fire.pb.util.MessageUtil;
import fire.pb.util.singlefactory.SingleContainer;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Map;
import mkdb.Procedure;
import xbean.RegDay;
import xbean.RegMonth;
import xbean.RegRec;

public class PSuppRegReward
extends RoleProcedure {
    private RegAssistant regAssistant;
    private int sRegDay;
    private static Logger logger = Logger.getLogger((String)"AWARD");

    public PSuppRegReward(long roleId, int suppregday, RegAssistant assistant) {
        super(roleId);
        this.sRegDay = suppregday;
        this.regAssistant = assistant;
    }

    public PSuppRegReward(long roleId, int suppsignday) {
        this(roleId, suppsignday, (RegAssistant)SingleContainer.getInstance(RegAssistant.class));
    }

    protected boolean process() throws Exception {
        Calendar calendar = Calendar.getInstance();
        int month = this.regAssistant.getMonthOfYear(calendar);
        int day = this.sRegDay;
        RegRec record = this.regAssistant.getRecord(this.roleId);
        Pack bag = new Pack(this.roleId, false);
        PropRole prole = new PropRole(this.roleId, true);
        int vipLevel = this.regAssistant.getVipLv(this.roleId);
        if (!record.getMonthmap().containsKey(month)) {
            logger.error((Object)("PSuppRegReward error:没有该月的记录  roleid:" + this.roleId + " month:" + month));
            return false;
        }
        int suppSignNum = ((RegMonth)record.getMonthmap().get(month)).getSuppregnum();
        if (suppSignNum < 1) {
            logger.error((Object)("PSuppRegReward error:补签次数异常  roleid:" + this.roleId + " suppSignNum:" + suppSignNum));
            return false;
        }
        Map days = ((RegMonth)record.getMonthmap().get(month)).getDaymap();
        if (!days.containsKey(day)) {
            logger.error((Object)("PSuppRegReward error:没有该日的记录  roleid:" + this.roleId + " day:" + day));
            return false;
        }
        if (((RegDay)days.get(day)).getRewardflag() > 0) {
            logger.error((Object)("PSuppRegReward error:今天已经领取过奖励  roleid:" + this.roleId + " day:" + day));
            return false;
        }
        int rewardId = this.getRewardId(days, month);
        if (rewardId < 1) {
            logger.error((Object)("PSuppRegReward error:奖励id错误  roleid:" + this.roleId + " rewardId:" + rewardId));
            return false;
        }
        int signNums = this.regAssistant.getRegTimesOfMonth(days);
        Sregreward ssignreward = (Sregreward)this.configManager.getConfigById(Sregreward.class, rewardId);
        if (ssignreward == null) {
            logger.error((Object)("PSuppRegReward error:奖励未配置  roleid:" + this.roleId + " rewardId:" + rewardId));
            return false;
        }
        int vipPercent = this.vipPercent(ssignreward, vipLevel);
        ((RegDay)days.get(day)).setRewardflag(1);
        ((RegMonth)record.getMonthmap().get(month)).setSuppregnum(suppSignNum - 1);
        record.setLastregtime(calendar.getTimeInMillis());
        logger.info((Object)("PSuppRegReward 补签奖励成功领取  roleid:" + this.roleId + " day:" + day + " rewardId:" + rewardId));
        return this.sendReward(prole.getUserid(), ssignreward, bag, vipPercent, signNums);
    }

    private int getRewardId(Map<Integer, RegDay> days, int month) {
        int total = this.regAssistant.getRegTimesOfMonth(days);
        if (total == 0) {
            return 0;
        }
        return total + month * 100;
    }

    protected boolean sendReward(int userId, Sregreward ssignreward, Pack bag, int vipPercent, int signNums) {
        if (ssignreward.getItemid() > 0 && ssignreward.getItemnum() > 0) {
            if (ssignreward.getItemnum() * vipPercent != bag.doAddItem(ssignreward.getItemid(), ssignreward.getItemnum() * vipPercent, 0, ssignreward.getIsbind(), "签到奖励", YYLoggerTuJingEnum.tujing_Value_qiandao, ssignreward.getItemid())) {
                MessageMgr.sendMsgNotify((long)this.roleId, (int)144965, null);
                return false;
            }
            MessageUtil.psendAddItemWhileCommit((long)this.roleId, (int)ssignreward.getItemid(), (int)ssignreward.getItemnum());
        }
        int mType = ssignreward.getMtype();
        switch (mType) {
            case 1: {
                if ((long)(ssignreward.getMoney() * vipPercent) != bag.addSysMoney((long)(ssignreward.getMoney() * vipPercent), "签到奖励", YYLoggerTuJingEnum.tujing_Value_jianglizhongxin, 0)) {
                    return false;
                }
                MessageUtil.pSendAddOrRemoveCurrency((long)this.roleId, (long)ssignreward.getMoney(), (int)1);
                break;
            }
            case 2: {
                if ((long)(ssignreward.getMoney() * vipPercent) != bag.addSysGold((long)(ssignreward.getMoney() * vipPercent), "签到奖励", YYLoggerTuJingEnum.tujing_Value_jianglizhongxin, 0)) {
                    return false;
                }
                MessageUtil.pSendAddOrRemoveCurrency((long)this.roleId, (long)ssignreward.getMoney(), (int)2);
                break;
            }
            case 3: {
                Procedure.pexecuteWhileCommit((Procedure)new PAddFuShi(userId, this.roleId, ssignreward.getMoney() * vipPercent, 1, YYLoggerTuJingEnum.tujing_Value_qiandao));
                MessageUtil.pSendAddOrRemoveCurrency((long)this.roleId, (long)ssignreward.getMoney(), (int)3);
            }
        }
        ItemBaseBean itembbean = new ItemBaseBean(ssignreward.getItemid(), ssignreward.getItemnum());
        ArrayList<ItemBaseBean> items = new ArrayList<ItemBaseBean>();
        items.add(itembbean);
        RegBean sibean = new RegBean(9001, signNums, items);
        YYLogger.signingLog((long)this.roleId, (RegBean)sibean);
        Procedure.pexecuteWhileCommit((Procedure)new PQueryRegRec(this.roleId));
        return true;
    }

    private int vipPercent(Sregreward ssignreward, int vipLevel) {
        if (vipLevel >= ssignreward.getRatio()) {
            return 2;
        }
        return 1;
    }
}

